<?php
/**
 * @package	Hikashop Order product Filter Plugin
 * @version	1.0.0
 * @author	HikaShop
 * @copyright	(C) 2010-2022 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class plgHikashopOrder_product_filter extends JPlugin
{
	public function __construct(&$subject, $config) {
		parent::__construct($subject, $config);

		$lang = JFactory::getLanguage();
		$lang->load('plg_hikashop_order_product_filter', JPATH_ADMINISTRATOR);
	}
	public function onBeforeOrderListing($paramBase, &$extrafilters, &$pageInfo, &$filters, &$tables, &$searchMap, &$select) {

		$extrafilters['product'] = $this;
		$app = JFactory::getApplication();
		$pageInfo->filter->filter_product_id = $app->getUserStateFromRequest($paramBase.".filter_product_id",'filter_product_id','','int');

		if(!empty($pageInfo->filter->filter_product_id)) {
			$select = ' DISTINCT b.order_id, '.$select;
			$tables['order_product'] = 'INNER JOIN '.hikashop_table('order_product').' AS order_product ON b.order_id = order_product.order_id ';
			$tables['product'] = 'INNER JOIN '.hikashop_table('product').' AS product ON (product.product_id = order_product.product_id OR (product.product_parent_id > 0 AND product.product_parent_id = order_product.product_id))';
			$filters[] = '( product.product_id = '.(int)$pageInfo->filter->filter_product_id.' OR product.product_parent_id = '.(int)$pageInfo->filter->filter_product_id.' )';
		}
	}

	public function displayFilter($name, $info) {
		$html = '';
		switch($name) {
			case 'product':
				$nameboxType = hikashop_get('type.namebox');	
				$html = $nameboxType->display(
					'filter_product_id',
					trim(@$info->filter_product_id),
					hikashopNameboxType::NAMEBOX_SINGLE,
					'product',
					array(
						'id' => 'filter_product_id',
						'delete' => true,
						'default_text' => '<em>'.JText::_('FILTER_BY_PRODUCT').'</em>',
						'variants' => 2,
						'url_params' => array('VARIANTS' => 2)
					)
				);
				$html.= "
					<script>
					window.Oby.ready(
						function() {
							setTimeout(
								function() {
									var w = window, ona = 'filter_product_id';
									if(!w.oNameboxes[ona])
										return;
									w.oNameboxes[ona].register('set', function(e) {
										document.adminForm.submit();
									});
								},
								500
							);
						}
					);
					</script>";
				if(!HIKASHOP_J40) {
					$html .="
					<style>
					#filter_product_id {
						width: 200px;
						display: inline-block;
						margin-bottom: -9px;
					}
					[data-oresize=\"filter_product_id\"]{
						width: 300px;
						left: auto !important;
					}
					</style>";
				}
				break;
			default:
				break;
		}
		return $html;
	}
}
